
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>CloudStack 创建VM源码的流程分析 / iVAN</title>

    <meta name="description" content="CloudStack 创建VM源码的流程分析 网上查找CloudStack源码的文章还是很少的,不像OpenStack那样多,花了两天的时间,将CloudStack 创建VM的源码读了一遍,感叹几点:创建一个VM流程中,查询操作数据库真多. 前几天听 CloudStack 的人说,CloudStack Management Server 装在一个16G/4C 的物理机上,运行半年,会挂掉,当时那个汗啊... 先把整理的流程图附上 下面按照每个步骤进行说明: 1.com.cloud.api.ApiServlet.processRequest(">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">CloudStack 创建VM源码的流程分析</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>网上查找CloudStack源码的文章还是很少的，不像OpenStack那样多，花了两天的时间，将CloudStack 创建VM的源码读了一遍，感叹几点：创建一个VM流程中，查询操作数据库真多。 前几天听 CloudStack 的人说，CloudStack Management Server 装在一个16G/4C 的物理机上，运行半年，会挂掉，当时那个汗啊。。。</p>
<p>先把整理的流程图附上</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2g0Lm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vMVU1NTFLTS0wLmdpZg==.jpg"></p>
<p>下面按照每个步骤进行说明：</p>
<p>1、com.cloud.api.ApiServlet.processRequest(HttpServletRequest, HttpServletResponse) 函数处理所有请求。具体处理登录、登出请求其他请求进行转发，进入下一步</p>
<p>2、com.cloud.api.ApiServer.handleRequest(Map, String, StringBuffer)</p>
<p>收到创建VM的请求，解析参数根据参数“command” 实例化处理该API的类，并将请求参数赋值到该类创建的对象，对于创建VM，实例化的类为：</p>
<p>org.apache.cloudstack.api.command.user.vm.DeployVMCmd。</p>
<p>由于继承自BaseAsyncCreateCmd，所以需要首先调用DeployVMCmd的create函数，再调用execute函数</p>
<p>Note:基于注解赋值：com.cloud.api.ApiDispatcher.processParameters(BaseCmd, Map&lt;String, String&gt;)，权限管理也是通过注解完成的。</p>
<p>3、org.apache.cloudstack.api.command.user.vm.DeployVMCmd.create()</p>
<p>3.1  检查zone、serviceoffering、templateId、diskoffering、zone是否启用了本地存储、获取ipv4,、ipv6地址，判断是基本zone，还是高级zone</p>
<p>3.2 如果是基本zone，需要调用函数</p>
<p>com.cloud.vm.UserVmManagerImpl.createBasicSecurityGroupVirtualMachine(DataCenter,ServiceOffering, VirtualMachineTemplate, List&lt;Long&gt;, Account, String, String, Long, Long, String, HypervisorType, HTTPMethod, String, String, Map&lt;Long, IpAddresses&gt;, IpAddresses, Boolean, String, List&lt;Long&gt;, Map&lt;String, String&gt;)</p>
<p>3.3 如果是高级zone，首先判断该zone是否启用了安全组，如果启用了安全组，调用函数</p>
<p>com.cloud.vm.UserVmManagerImpl.createAdvancedSecurityGroupVirtualMachine(DataCenter, ServiceOffering, VirtualMachineTemplate, List&lt;Long&gt;, List&lt;Long&gt;, Account, String, String, Long, Long, String, HypervisorType, HTTPMethod, String, String, Map&lt;Long, IpAddresses&gt;, IpAddresses, Boolean, String, List&lt;Long&gt;, Map&lt;String, String&gt;)</p>
<p>如果没有启用安全组，调用函数：</p>
<p>com.cloud.vm.UserVmManagerImpl.createAdvancedVirtualMachine(DataCenter, ServiceOffering, VirtualMachineTemplate, List&lt;Long&gt;, Account, String, String, Long, Long, String, HypervisorType, HTTPMethod, String, String, Map&lt;Long, IpAddresses&gt;, IpAddresses, Boolean, String, List&lt;Long&gt;, Map&lt;String, String&gt;)</p>
<p>以在基本zone创建VM为例，进行源码阅读</p>
<p>4、函数</p>
<p>com.cloud.vm.UserVmManagerImpl.createBasicSecurityGroupVirtualMachine(DataCenter,ServiceOffering, VirtualMachineTemplate, List&lt;Long&gt;, Account, String, String, Long, Long, String, HypervisorType, HTTPMethod, String, String, Map&lt;Long, IpAddresses&gt;, IpAddresses, Boolean, String, List&lt;Long&gt;, Map&lt;String, String&gt;)</p>
<p>(4.1) 根据zoneId 获取该zone内的默认网络,执行的SQL</p>
<p>select *from networks where data_center_id=1 and account_id=1 and guestType=’Shared’ and traffic_type=’Guest’;</p>
<p>将查询到的默认网络保存到内存，后面使用.(需要将虚拟机加入到该网络，进行管理)</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-19 10:09:49</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/string/" title="string">string</a>, <a href="https://www.iamivan.net/tag/list/" title="list">list</a>, <a href="https://www.iamivan.net/tag/cloud/" title="Cloud">Cloud</a>, <a href="https://www.iamivan.net/tag/long/" title="long">long</a>, <a href="https://www.iamivan.net/tag/cloudstack/" title="cloudstack">cloudstack</a>, <a href="https://www.iamivan.net/tag/cloudstack%e6%8a%80%e6%9c%af%e6%b2%99%e9%be%99/" title="cloudstack技术沙龙">cloudstack技术沙龙</a>, <a href="https://www.iamivan.net/tag/cloudstack-iso/" title="cloudstack iso">cloudstack iso</a>, <a href="https://www.iamivan.net/tag/cloudstack%c2%a0hyper-v%c2%a0/" title="CloudStack&nbsp;hyper-v&nbsp;">CloudStack&nbsp;hyper-v&nbsp;</a>, <a href="https://www.iamivan.net/tag/cloudstack4-8/" title="cloudstack4&period;8">cloudstack4&period;8</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>CloudStack 创建VM源码的流程分析的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRqZXdb.html" rel="bookmark">求android-support-v4源码打包流程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 求android-support-v4源码打包流程 求android-support-v4源码打包流程,我有个文件要改android-support-v4,求知道的大神告诉我一下,谢谢了 解决方案 为android-support-v4.jar打包源码 解决方案二: 我打的包只有443KB导入到项目报一堆的错			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MNj2QWM.html" rel="bookmark">spring源码如何引入分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 spring源码如何引入分析 最近想学习一下spring源代码 我下载spring源码后 新建一个springmvc工程,在工程中 java build path里导入下载的spring源码,提示找不到类 java.lang.ClassNotFoundException: org.springframework.web.context.ContextLoaderListener 看了一下部署文件里,的确没有之前引入的源代码,我该怎么让它跑起来? 解决方案 http://www.2cto			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBdwQ4p.html" rel="bookmark">【代码管理】GitHub超详细图文攻略 - Git客户端下载安装 GitHub提交修改源码工作流程 Git分支 标签 过滤 Git版本工作流</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				找到一篇很详细的Git教程,真的很不错,推荐!!! GitHub操作总结 : 总结看不明白就看下面的详细讲解. . 作者 :万境绝尘  . GitHub操作流程 : 第一次提交 :   方案一 : 本地创建项目根目录, 然后与远程GitHub关联, 之后的操作一样; -- 初始化git仓库 :git init ; -- 提交改变到缓存 :git commit -m 'description' ; -- 本地git仓库关联GitHub仓库 : git remote add origin git@g			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/1MvwVAp.html" rel="bookmark">CloudFoundry warden 创建container 源码研究</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				阅读完 warden启动的源码,又看了创建container的源码: 在lib/warden/server.rb中,run!方法下,使用了EM的start_unix_domain_server的方法启动了一个unixsock,第二个参数ClientConnection定义了接收到东西怎么处理,ClientConnection中的process方法具体处理了create: when Protocol::CreateRequest container = Server.container_klass			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPk6rvM.html" rel="bookmark">JVM源码分析之一个Java进程究竟能创建多少线程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				概述 虽然这篇文章的标题打着JVM源码分析的旗号,不过本文不仅仅从JVM源码角度来分析,更多的来自于Linux Kernel的源码分析,今天要说的是JVM里比较常见的一个问题 这个问题可能有几种表述 一个Java进程到底能创建多少线程? 到底有哪些因素决定了能创建多少线程? java.lang.OutOfMemoryError: unable to create new native thread的异常究竟是怎么回事 不过我这里先声明下可能不能完全百分百将各种因素都理出来,因为毕竟我不是做Lin			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bamkPPb.html" rel="bookmark">《Netty 权威指南》&mdash;&mdash; NIO创建的TimeClient源码分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				声明:本文是&lt;Netty 权威指南&gt;的样章,感谢博文视点授权并发编程网站发布样章,禁止以任何形式转载此文. 我们首先还是看下如何对TimeClient进行改造: public class TimeClient { /** * @param args */ public static void main(String[] args) { int port = 8080; if (args != null &amp;&amp; args.length &gt; 0) { try { port =			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MR1K58b.html" rel="bookmark">从源码分析Android的Volley库的工作流程&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Volley现在已经被官方放到AOSP里面,已经逐步成为Android官方推荐的网络框架. 类抽象 对Http协议的抽象 Requeset顾名思义,对请求的封装,实现了Comparable接口,因为在Volley中是可以指定请求的优先级的,实现Comparable是为了在Request任务队列中进行排序,优先级高的Request会被优先调度执行.NetworkResponseHttp响应的封装,其中包括返回的状态码 头部 数据等.Response给调用者返回的结果封装,它比NetworkResp			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b32amWz.html" rel="bookmark">深入理解Spark：核心思想与源码分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				大数据技术丛书 深入理解Spark:核心思想与源码分析 耿嘉安 著 图书在版编目(CIP)数据 深入理解Spark:核心思想与源码分析/耿嘉安著. -北京:机械工业出版社,2015.12 (大数据技术丛书) ISBN 978-7-111-52234-8 I. 深- II.耿- III.数据处理软件 IV. TP274 中国版本图书馆CIP数据核字(2015)第280808号 深入理解Spark:核心思想与源码分析 出版发行:机械工业出版社(北京市西城区百万庄大街22号 邮政编码:100037)			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p8kO3NM.html" rel="bookmark">JVM源码分析之javaagent原理完全解读</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 本系列文章都是基于Hotspot/JDK源码,从源码角度来分析我们常见的JVM参数,Java概念以及对应的实现原理及玩法等,希望从根本上来理清Java知识点,我们会不定期地分享这个系列的文章,这些文章可能源于最近碰到的问题,也可能是同学们的提问,甚至有可能是我们突然想到的话题等,有些东西我们现在可能也不一定清楚,但是我们非常愿意花时间去了解清楚并分享给大家. 概述 本文重点讲述javaagent的具体实现,因为它面向的是我们java程序员,而且agent都是用java编写的,不需要太多的c			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ybj245b.html" rel="bookmark" class="title">XHTML&plus;CSS兼容性解决方案小总结</a>
					<div>
						css|xhtml|解决 使用XHTML+CSS构架好处不少,但也确实存在一些问题,不论是因为使用不熟练还是思路不清晰,我就先把一些我遇到的问题写在下面,省的大家四处找. 1.在mozilla fir ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qMqm33M.html" rel="bookmark" class="title">一些iptables的具体应用</a>
					<div>
						ICMP相关应用 使自己不能ping 通 127.0.0.1 iptables -A INPUT -s 127.0.0.1 -p icmp -j DROP 192.168.0.0/24 网段无法pin ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9zejoVb.html" rel="bookmark" class="title">浅谈ASP程序的编写和调试：给初学者</a>
					<div>
						程序|初学 很多朋友觉得ASP不是很好学,我觉得其实有了一定的编程基础,再加上那么一点点技巧,入门是不难的(不过要做好也不是很容易,要很多的相关知识--什么Sql Server数据库语言啦,数据结构啦 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMgAa5z.html" rel="bookmark" class="title">测试访问者电脑的分辨率</a>
					<div>
						访问|分辨率 &lt;!-- Saved From url=http://网址 --&gt;&lt;!-- Web Design bbs url=http://网址--&gt; &lt;SCRIPT  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2MWYoez.html" rel="bookmark" class="title">Dreamweaver MX创造网页鼠标样式</a>
					<div>
						dreamweaver|鼠标|鼠标样式|网页 经常在网上冲浪的朋友是否曾注意到有些网站的鼠标不是规则的斜向上箭头的形状,而是&quot;十&quot;字形,或者是向左的箭头,或者是个问号等等.当你想在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/rz4x3qz.html" rel="bookmark" class="title">SEO菜鸟三个月内如何实现百度权重3 送给即将启程的站长</a>
					<div>
						小弟接触SEO并不是很久,懂的也很浅薄,今天只是把自己曾经走过的一些路和得到一些经验跟大家分享,高手们可以绕道啦~     先说说小弟这几个月的劳动成果,目前做的这个微小说站站长工具权重3,PR1(目 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQP1Jrz.html" rel="bookmark" class="title">为何在Coreldraw中建立新文件会失败</a>
					<div>
						问:有时候在Coreldraw中建立新文件会失败,是怎么回事?该怎么办呢? 答:这通常是打印机故障问题,特别是网络打印机问题,一般出现在XP或2000系统上的盗版Coreldraw9. 解决方法: 打 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1R6o5p.html" rel="bookmark" class="title">在Word 2010文档中创建书签超链接</a>
					<div>
						在Word 2010文档中,通过使用书签功能可以快速定位到本文档中的特定位置.用户可以创建书签超链接,从而实现链接到同 一Word文档中特定位置的目的,操作步骤如下所述: 第1步,打开Word 201 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY2a15p.html" rel="bookmark" class="title">怎么查看qq拼音输入法打了多少字？</a>
					<div>
						  qq拼音输入法查看打了多少字操作步骤: 1.右键单击输入条,点击个人中心: qq拼音输入法 2.在个人中心可以查看自己每天通过QQ输入法打出的字数:					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrK6g6p.html" rel="bookmark" class="title">Linux版WPS问世：Linux国内普及再进一步</a>
					<div>
						2013年2月份中旬,金山软件发布了Linux版本的WPS,从官方的截图和笔者实际安装体验中看来,这款Linux版本的WPS在使用习惯和功能上与Windows版本的WPS并无太大的差别,如果不注意观察 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK7WEAb.html" rel="bookmark" class="title">jQuery验证插件validation使用指南</a>
					<div>
						  jquery.validation.js在前端验证中使用起来非常方便,提供的功能基本上能满足大部分验证需求,下面我们就来仔细研究下这款jQuery插件的具体使用方法. 在网站开发过程中,有时我们需 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M62XaOM.html" rel="bookmark" class="title">Excel如何快速对齐图片和单元格</a>
					<div>
						  1.首先我们自然是要将插入的图片设置为统一的高度和宽度,调整为同样大小. 2.按ctrl+g组合键将图片全选,接着打开定位窗口,然后选择&quot;定位条件&quot;为&quot;对象&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE64EnM.html" rel="bookmark" class="title">session问题-JavaWeb应用中出现的问题</a>
					<div>
						问题描述 JavaWeb应用中出现的问题 用request.getParameter()这个方法从前一个页面获取值,然后把它获得到的值放到session中,就是用session.setAttribut ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE6Ed9M.html" rel="bookmark" class="title">学生宿舍管理系统（VS2005&plus;SQL2000）</a>
					<div>
						问题描述 那位有的可以发给我不我邮箱:pilyj@163.com 解决方案 解决方案二:楼主,天底下没有免费的午餐呀!解决方案三:难道是毕业设计,google查,或者自己做.解决方案四:呵呵					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBZnrKb.html" rel="bookmark" class="title">如何通过一张图片，找到另一张图片？</a>
					<div>
						如果用户给出一张图片,百度识图会判断里面是否出现人脸,如果有,百度识图在相似图片搜索之外,同时会全网寻找出现过的类似人像. 如何通过一张图片,找到另一张图片? 对于搜索引擎而言,寻找图片之间的内在联系 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKQvNAp.html" rel="bookmark" class="title">poj 3687 Labeling Balls 逆向拓扑</a>
					<div>
						  要求输出每个球的重量,标号越小的重量越轻越好.   逆向拓扑,从大向小查找入度为0的点,然后赋予最大的值,这样就可以保证小号重量轻了   好久没敲代码了,完全不会敲了 /* author:jxy  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJkaV6b.html" rel="bookmark" class="title">RPM打包利器RPM&lowbar;CREATE</a>
					<div>
						Normal 0 7.8 磅 0 2 false false false MicrosoftInternetExplorer4        RPM 是 Redhat Package Manager  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgR99Bb.html" rel="bookmark" class="title">原则能增加说服力</a>
					<div>
						有的人为什么会有这么的说服力?美国风险投资家.专业文档查询和交流网站Docstoc.com联合创始人詹森·纳扎尔(Jason Nazar)对当今最有影响的政治.社会.商业和宗教领袖都做了研究之后,总结 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlLQ3LM.html" rel="bookmark" class="title">c&num; winform 怎么让textbox中的字输一个就自动换一行，如图</a>
					<div>
						问题描述 也就是竖着显示,注意:每输入一个字后就立马自动回车换新行 解决方案 解决方案二:http://bbs.csdn.net/topics/350205641解决方案三:如果是等候用户输入完毕后, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeoo39M.html" rel="bookmark" class="title">浅谈JavaScript中小数和大整数的精度丢失&lowbar;javascript技巧</a>
					<div>
						先来看两个问题: 0.1 + 0.2 == 0.3; // false 9999999999999999 == 10000000000000000; // true 第一个问题是小数的精度问题,在业界 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mye9lkM.html" rel="bookmark" class="title">水井坊陷&OpenCurlyDoubleQuote;混乱期&rdquo;本地高管无心工作外企人员未进入</a>
					<div>
						业内人士表示,目前水井坊遇到的问题有行业调整.企业管理层的交接.高端酒销售受阻.低价位品牌酒还没有形成等帝亚吉欧花费七年时间,终于将水井坊全部纳入怀中.在业内人士看来,帝亚吉欧不惜巨资收购业绩下降的水 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeoVB0M.html" rel="bookmark" class="title">C&plus;&plus;编写的dll怎么在C&num;中使用，该dll是在网上下载的。</a>
					<div>
						问题描述 是不是可以再次编辑或者什么的,总之能在c#中引用就可以了,求各位大神指导. 解决方案 解决方案二:c#调用一个C++DLL文件,你需要首先了解C++的一些声明接口,利用P-Invoke或者其 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYXP5lb.html" rel="bookmark" class="title">浅析互联网流量生存潜规则</a>
					<div>
						互联网本质其实就是个工具或者是个平台,而我们就在尝试着通过流量的来路与出路的梳理来清晰地看出各种不同商业模式的生存潜规则. 一.首先是各类不同的网站的形态:地.火.风.水 像各式各样的网站,其实大致可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn8xL0b.html" rel="bookmark" class="title">电影产业深度&OpenCurlyDoubleQuote;触网&rdquo;：电影公司为&OpenCurlyDoubleQuote;BAT&rdquo;打工？</a>
					<div>
						互联网正在深度影响生活各个方面,电影产业也不例外. 在昨日第十七届上海国际电影节&quot;视频网站引领电影业变革&quot;论坛传递的信息显示,互联网巨头凭借在用户数量.网络播放渠道.大数据分析.在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYN4lep.html" rel="bookmark" class="title">JavaScript写的一个DIV 弹出网页对话框&lowbar;javascript技巧</a>
					<div>
						网上搜索到的代码,做了一些修改该, 修正无法自定义颜色,修正IE8 下错误,以及其他小BUG 兼容IE6~8以及火狐 可以自定义 // 提示窗口标题高度 // 提示窗口的边框颜色 // 提示窗口的标题 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z44Lrqz.html" rel="bookmark" class="title">动态添加删除表格行的js实现代码&lowbar;javascript技巧</a>
					<div>
						复制代码 代码如下: &lt;html&gt;&lt;head&gt;&lt;script language=&quot;javascript&quot;&gt;  //窗口表格增加一行  funct ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZ21a4z.html" rel="bookmark" class="title">html文本框提示效果的示例代码&lowbar;javascript技巧</a>
					<div>
						完整代码如下: 复制代码 代码如下: &lt;!DOCTYPE html PUBLIC &quot;-//W3C//DTD XHTML 1.0 Transitional//EN&quot;&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8Nqa9b.html" rel="bookmark" class="title">DDS倒闭后遗症</a>
					<div>
						案例1 被卖 &quot;猪仔&quot; 找不到负责方 陈女士:上月21日,我让DDS快递公司收件寄到河北,DDS快递方面又托付给圆通快递来投送.而邮件送到河北的时候,却因为收件人以邮件损坏为由拒收 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV7KXBb.html" rel="bookmark" class="title">高管背景与创业板公司估值泡沫</a>
					<div>
						鲁桂华 在过去的研究中,我们发现,A股市场市盈率最高的那些上市公司,在未来的5年间,其市盈率大幅度下降,并且在第二年和第三年,这些公司的市盈率下降幅度最大.就目前A股市场的整体情况来看,创业板的市盈率 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgPE7Zp.html" rel="bookmark" class="title">为何苹果可能给iPhone&comma;6配备蓝宝石屏幕？</a>
					<div>
						在多家权威媒体报道苹果将会在,9,月,9,日举行,iPhone,6,发布会之后,苹果社区对这款设备的期待度又更上一层楼.目前坊间不断曝光各种关于新设备的消息,而其中最难以确定的就是新设备的屏幕.蓝宝石 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
